/**
  ******************************************************************************
  * @file           : main.c
  * @author         ：SINOMCU-AE
  * @brief          : Main program body
  *  
  *          This file provides example code for Power Standby mode and printf by uart.
  * Run 5S,than enter sleep mode,WKUP1(PA0) rising edge reset system,also can be reset key.
  * For details, see "readme.txt"
  *         
  ******************************************************************************
   * @attention 
  *                           DISCLAIMER
  * The present firmware which is for guidance only aims at providing customers
  * with coding information regarding their products in order for them to save
  * time. As a result, SinoMCU shall not be held liable for any direct,indirect
  * or consequential damages with respect to any claims arising from the content 
  * of such firmware and/or the use made by customers of the coding information 
  * contained herein in connection with their products.
  *
  * <h2><center>&copy; Copyright (c) 2021 sinomcu All rights reserved.</center></h2>
  *
  ******************************************************************************
  */  
  
#include "system_define.h"

#define SYSCLK_USE_PLL_48M             0    // 1:sysclk PLL48M,0:HSI 8M 

#define COUNT_PERIOD                   500  // count period in ms
#define ENTER_STANDBY_DELAY_COUNT      10   // ENTER_STANDBY_DELAY_COUNT * COUNT_PERIOD
#define DELAY_FOR_UART_SEND            2    // unit ms

__IO FlagStatus EXIT_Trigger = RESET;

int main(void) 
{
  __IO FlagStatus WakeUp_Flag =RESET;
  __IO uint32_t run_count = 0;
  uint8_t sleep_enter_count = 0;
  
#if(defined(SYSCLK_USE_PLL_48M) && SYSCLK_USE_PLL_48M) 
  sysclk_init();                            // sysclk 48M,HSI 8M /2*12;if not call this function,default HSI 8M
#endif
  SystemCoreClockUpdate();                  // get System Core Clock
    
  sys_tick_init();
  gpio_init();
#if(defined(EN_PRINT_UART) && EN_PRINT_UART) 
  MS32_RCC_SetUSARTClockSource(MS32_RCC_USART1_CLKSOURCE_HSI);       // uart clk HSI 8M   
  usart1_uart_init(115200);
#endif
  
  MS32_APB1_GRP1_EnableClock(MS32_APB1_GRP1_PERIPH_PWR);
  MS32_PWR_EnableWakeUpPin(MS32_PWR_WAKEUP_PIN1);                    // enable wake up pin1 PA0 can reset system from standby mode
  
  printf("\r\n\r\n*****Power StandBy PA0 WakeUP Example*****");
  printf("\r\n--Inf:System Core Clock %d Hz.",SystemCoreClock); 
  
  Start_User_MS_SF_Timer(COUNT_PERIOD);
  while(1) {
    if(Get_State_User_MS_SF_Timer() == SF_TIMER_OV) {
      Start_User_MS_SF_Timer(COUNT_PERIOD);                          // clear Software timer OV
      LED1_TOGGLE();
      run_count++;
      printf("\r\n--Inf: running count:%d",run_count);

      sleep_enter_count++;
      if(sleep_enter_count == ENTER_STANDBY_DELAY_COUNT) {           // before enter standby mode count 5S
        sleep_enter_count =0;
        printf("\r\n--Inf:Enter StanBy Mode,Press reset key or wakeup1(PA0) to high!"); 
        MS32_mDelay(DELAY_FOR_UART_SEND);                            // delay for uart send finish

        MS32_PWR_EnterSTANDBYMode();
      }
    }
  }
}

/**
  * @brief  SystemClock_Config HSI/2 to PLL*12 sysclk 48M
  * @param  None
  * @retval None
  */
void sysclk_init(void) {
  MS32_RCC_OscInitTypeDef osc_cfg;
  MS32_RCC_PllInitTypeDef pll_cfg;
  MS32_RCC_ClkInitTypeDef clk_cfg;

  // get and clear reset flag 
  MS32_RCC_GetResetFlag(ENABLE);
  
  // osc config 
  osc_cfg.HSIState = MS32_RCC_HSI_ON;
  osc_cfg.HSEState = MS32_RCC_HSE_OFF;
  osc_cfg.LSIState = MS32_RCC_LSI_OFF;
//  osc_cfg.LSEState = MS32_RCC_LSE_ON_DRV_H;
  MS32_RCC_OscConfig(&osc_cfg);
  
  // pll config 
  pll_cfg.PLLState  = MS32_RCC_PLL_ON;
  pll_cfg.PLLSource = MS32_RCC_PLL_SOURCE_HSI_DIV_2;       // HSI/2 4M
  pll_cfg.PLLMUL    = MS32_RCC_PLL_MUL12;
  pll_cfg.PREDIV    = MS32_RCC_PLL_PREDIV_DIV1;
  MS32_RCC_PllConfig(&pll_cfg);
  
  // sysclk config 
  clk_cfg.SYSCLKSource   = MS32_RCC_SYSCLK_SOURCE_PLL;
  clk_cfg.AHBCLKDivider  = MS32_RCC_SYSCLK_DIV1;
  clk_cfg.APB1CLKDivider = MS32_RCC_HCLK_DIV1;
  MS32_RCC_ClockConfig(&clk_cfg);
}

/******************************** END OF FILE *********************************/
